<?php
/**
*
* @package phpBB3
* @version $Id: go.php,v 0.2.0 2011/12/15 00:19:00 doktornotor Exp $
* @copyright (c) 2005 phpBB Group 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/go');

// Get the avatar
if (!function_exists('get_user_avatar'))
{
   include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
}

$base_url = generate_board_url() . '/';

// get referrer host name from URL
if (isset($_SERVER['HTTP_REFERER'])) {
	preg_match('@^(?:http://)?([^/]+)@i',
		$_SERVER['HTTP_REFERER'], $matches);
	$host = $matches[1];
	// get last two segments of host name
	preg_match('/[^.]+\.[^.]+$/', $host, $matches);
	$referrer = $matches[0];
}

// get our host name
$our_host = $_SERVER['SERVER_NAME'];
// get last two segments of our site name
preg_match('/[^.]+\.[^.]+$/', $our_host, $our_matches);
$our_referrer = $our_matches[0];

// set a fallback redirect url pointing to our site index
$our_redir_url = urlencode( 'http://' . ($_SERVER['SERVER_NAME']));
// set an error redirect url pointing to the 400/403 error page
$error_400_url = urlencode($phpbb_root_path . 'error.php?mode=400');
$error_403_url = urlencode($phpbb_root_path . 'error.php?mode=403');

// check whether we have something to redirect to
$url = str_replace('&','&amp;', $_SERVER["REQUEST_URI"]);
$url = str_replace($_SERVER["SCRIPT_NAME"] . '?', '', $url);

// validate the result
if (!filter_var($url, FILTER_VALIDATE_URL)) {
	send_status_line(400, 'Bad Request');
	header('Location: '.urldecode($error_400_url));
	exit;
} else {
	$redir_url = (($url == $_SERVER['SCRIPT_URI']) ? $our_redir_url : urlencode($url));
}

// we do not act as anonymous redirect site
if ((!isset($referrer) || ($referrer != $our_referrer))) {
	send_status_line(403, 'Forbidden');
	header('Location: '.urldecode($error_403_url));
	exit;
} else {
// send the user whereever the link points via our redirect page
	page_header('Leaving The Forum Now');

	$template->set_filenames(array(
		'body' => 'go_body.html',
	));

	$template->assign_vars(array(
		'S_REDIRECT_TIME'	=> 3,
		'S_USERNAME'		=> get_username_string('full', $user->data['user_id'], $user->data['username'], $user->data['user_colour']),
		'USER_AVATAR'		=> get_user_avatar($user->data['user_avatar'], $user->data['user_avatar_type'], $user->data['user_avatar_width'], $user->data['user_avatar_height']),
		'U_FORUM_BASE'		=> $base_url,
		'U_REDIRECT_URL'	=> urldecode($redir_url),
	));

page_footer();

}
?>